"""
Autogenerated module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__
"""


async def sddcs(hub, ctx, org: str, include_deleted: bool = None) -> None:
    """
    **Autogenerated function**
    
    List all the SDDCs of an organization

    Args:
        org(str): Organization identifier.
        include_deleted(bool, optional): When true, forces the result to also include deleted SDDCs. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.sddcs(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.sddcs org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs".format(**{"org": org}),
        query_params={"includeDeleted": include_deleted},
        data={}
    )


async def sddc_patch_request(hub, ctx, org: str, sddc: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.
        sddc(str): Sddc identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.sddc_patch_request(ctx, org=value, sddc=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.sddc_patch_request org=value, sddc=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="patch",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/{sddc}".format(**{"org": org, "sddc": sddc}),
        query_params={},
        data={}
    )


async def clusters(hub, ctx, org: str, sddc: str, cluster: str) -> None:
    """
    **Autogenerated function**
    
    This is a force operation which will delete the cluster even if there can be a data loss. Before calling this operation, all the VMs should be powered off.

    Args:
        org(str): Organization identifier.
        sddc(str): Sddc identifier.
        cluster(str): cluster identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.clusters(ctx, org=value, sddc=value, cluster=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.clusters org=value, sddc=value, cluster=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="delete",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/{sddc}/clusters/{cluster}".format(**{"org": org, "sddc": sddc, "cluster": cluster}),
        query_params={},
        data={}
    )


async def sddc_config(hub, ctx, org: str, validate_only: bool = None) -> None:
    """
    **Autogenerated function**
    
    Provision an SDDC in target cloud

    Args:
        org(str): Organization identifier.
        validate_only(bool, optional): When true, only validates the given sddc configuration without provisioning. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.sddc_config(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.sddc_config org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs".format(**{"org": org}),
        query_params={"validateOnly": validate_only},
        data={}
    )


async def provision_spec(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Get sddc provision spec for an org

    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.provision_spec(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.provision_spec org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/provision-spec".format(**{"org": org}),
        query_params={},
        data={}
    )


async def sddc_convert_request(hub, ctx, org: str, sddc: str) -> None:
    """
    **Autogenerated function**
    
    This API converts a one host SDDC to a 3 node DEFAULT SDDC. It takes care of configuring and upgrading the vCenter configurations on the SDDC for high availability and data redundancy.

    Args:
        org(str): Organization identifier.
        sddc(str): Sddc identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.sddc_convert_request(ctx, org=value, sddc=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.sddc_convert_request org=value, sddc=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/{sddc}/convert".format(**{"org": org, "sddc": sddc}),
        query_params={},
        data={}
    )


async def cluster_config(hub, ctx, org: str, sddc: str) -> None:
    """
    **Autogenerated function**
    
    Creates a new cluster in customers sddcs with passed clusterConfig.

    Args:
        org(str): Organization identifier.
        sddc(str): Sddc identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.sddc.cluster_config(ctx, org=value, sddc=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.sddc.cluster_config org=value, sddc=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/sddcs/{sddc}/clusters".format(**{"org": org, "sddc": sddc}),
        query_params={},
        data={}
    )

